/* topblock - openGL based hack  */

static void buildCarpet(ModeInfo *);
static void polygonPlane(int, int, int, int, int ,int);
static void buildBlock(ModeInfo *);
static void generateNewBlock(ModeInfo *);
static void followBlock(ModeInfo *);
static void buildBlobBlock(ModeInfo *);
static double quadrantCorrection(double,int,int,int,int);

/* this structure holds all the attributes about a block */
typedef struct blockNode {
	int color;		/* indexed */
	int rotation;		/* indexed: 0=S-N, 1=W-E, 2=N-S, 3=E-W */
	GLfloat height;
	GLfloat x;
	GLfloat y;
	int falling;		
	struct blockNode *next;
} NODE;


/* some handy macros and definitions */
#define blockHeight 1.49f
#define getHeight(a) (a * blockHeight)

#define getOrientation(a) (a * 90)

#define blockWidth 2.0f
#define getLocation(a) (a * blockWidth)

#define TOLLERANCE 0.1

#define cylSize 0.333334f
#define uddSize 0.4f
#define	singleThick 0.29	/* defines the thickness of the carpet */


const GLfloat MAT_Red[] = { 1.0f, 0.0f, 0.0f, 1.0f };	
const GLfloat MAT_Green[] = { 0.0f, 1.0f, 0.0f, 1.0f };	
const GLfloat MAT_Blue[]= { 0.0f, 0.0f, 1.0f, 1.0f };	
const GLfloat MAT_White[]= { 0.95f, 0.95f, 0.95f, 1.0f };	
const GLfloat MAT_Black[]= { 0.05f, 0.05f, 0.05f, 1.0f };	
const GLfloat MAT_Yellow[]= { 1.0f, 1.0f, 0.0f, 1.0f };	
const GLfloat MAT_Grey[]= { 0.5f, 0.5f, 0.5f, 1.0f };	
const GLfloat MAT_Brown[]= { 1.0f, 0.5f, 0.0f, 1.0f };

const GLfloat FLAT_Red[] = { 1.0f, 0.0f, 0.0f };	
const GLfloat FLAT_Green[] = { 0.0f, 1.0f, 0.0f};	
const GLfloat FLAT_Blue[]= { 0.0f, 0.0f, 1.0f};	
const GLfloat FLAT_White[]= { 0.95f, 0.95f, 0.95f};	
const GLfloat FLAT_Black[]= { 0.05f, 0.05f, 0.05f};	
const GLfloat FLAT_Yellow[]= { 1.0f, 1.0f, 0.0f};	
const GLfloat FLAT_Grey[]= { 0.5f, 0.5f, 0.5f};	
const GLfloat FLAT_Brown[]= { 1.0f, 0.5f, 0.0f};

/* this is the 5 sides of a single block */
const GLfloat topBlockVertices[][3] = {
			{-0.49,-2.97,-0.99}, {0.99,-2.97,-0.99},
			{0.99,0.99,-0.99}  , {-0.49,0.99,-0.99}, 
			{-0.49,-2.97,0.99} , {0.99,-2.97,0.99}, 
			{0.99,0.99,0.99}   , {-0.49,0.99,0.99}
		};

/* normals, used for lighting */
const GLfloat topBlockNormals[][3] = {
			{0,0,-1},
			{0,1,0},
			{1,0,0},
			{0,0,1},
			{0,-1,0}
		};


